# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

class Backends::TerraformAwsJob < Que::Job
  def run(terraform_aws_backend_id, action)
    ActiveRecord::Base.transaction do
      @backend = Backends::TerraformAws.find(
        terraform_aws_backend_id
      )

      @backend.send(action)

      finish
    end
  end

  def self.job_title(que_job)
    que_job.args.last.titleize
  end

  def self.jobs(terraform_aws_backend_id)
    QueJob
      .where(
        job_class: name
      ).where(
        "args->>0 = '#{terraform_aws_backend_id}'"
      )
  end
end
