# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

module Backends
  def self.table_name_prefix
    'backends_'
  end

  def self.classes
    [
      Backends::TerraformAws,
      Backends::TerraformLibvirt
    ]
  end

  def self.classes_with_backends
    classes.select do |backend_class|
      backend_class.all.any?
    end
  end

  def self.all
    classes.flat_map(&:all)
  end

  def self.find_by_type_and_id(type_name, id)
    type = classes.find { |c| c.name == type_name }

    type.find(id.to_i)
  end
end
