namespace :backend do
  namespace :terraform_libvirt do
    desc 'Deploy a Terraform libvirt backend'
    task :deploy, [:backend_id] => :environment do |t, args|
      Backends::TerraformLibvirt
        .find(args.backend_id)
        .deploy_backend
    end
  end

  namespace :terraform_aws do
    desc 'Deploy a Terraform AWS backend'
    task :deploy, [:backend_id] => :environment do |t, args|
      Backends::TerraformAws
        .find(args.backend_id)
        .deploy_backend
    end

    desc 'Destroy a Terraform AWS backend'
    task :destroy, [:backend_id] => :environment do |t, args|
      Backends::TerraformAws
        .find(args.backend_id)
        .destroy_backend
    end
  end
end
